#ifndef FC__FC_TYPES_H
#define FC__FC_TYPES_H
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#define TRUE true
#define FALSE false


#define MAX_LEN_NAME 32

#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))


typedef int Nation_Type_id;
typedef int Unit_Type_id;

struct player {
  char name[MAX_LEN_NAME];

  Nation_Type_id nation;
  int player_no;
};

struct nation {
  const char *name;
  const char *name_plural;

  const int index;
};

struct city {
  char name[MAX_LEN_NAME];

  int owner;
  struct tile *tile;

  int id;
};

struct unit {
  Unit_Type_id type;
  int owner;
  int homecity;
  struct tile *tile;

  int id;
};

struct tile {
  const int nat_x, nat_y;

  const int index;
};

#endif

